<?php

include 'core.php';

checkAuth("CA");

cabecera (4);

$command = $_POST ["csr_command"];
$errorCode = "a0";

switch ( $command ) {

   default:
      // Nos traemos el numero copa, el identificador y la fecha de los 
      // certificados emitidos y revocados, y de las solicitudes rechazadas
      // pendientes de ser enviadas a la RA
      $filter = "(&(objectClass=pkirisCertificate)(|(pkirisStatus=issued)(pkirisStatus=revoked*)(pkirisStatus=*refused)))";
      echo "<h1>Certificados, revocaciones y/o solicitudes rechazadas pendientes de ser enviados a la RA</h1>\n";
      
      $justthese = array ("pkirisid","pkiriscopaid","pkirisdate", "pkirisstatus");
      $result = ldap_get_info($ldapVar['base'],$filter,$justthese);
      if ( !$result )
         $errorCode = "a2b1c3d1e1";
      else if ($result["count"] == 0)
         echo "<p>No hay peticiones Nuevas</p>";      
      else {
         echo "<table border='0' cellpadding='0' cellspacing='0'>
           <tr>
             <th class='header'>C&oacute;digo</th>
             <th class='header'>Identificador</th>
             <th class='header'>Fecha</th>
             <th class='header'>Estado</th>
           </tr>
          <form method='post' action='data_export.php?sessionID=$sessionID' enctype='multipart/form-data' name='csr_makeXml'>\n";

         for($i = 0; $i < $result["count"]; $i++) {
            $copa = $result[$i]["pkiriscopaid"][0];
            $ident = $result[$i]["pkirisid"][0];
            $anio = substr($result[$i]["pkirisdate"][0], 0, 4);
            $mes = substr($result[$i]["pkirisdate"][0], 4, 2);
            $dia = substr($result[$i]["pkirisdate"][0], 6, 2);
            $hora = substr($result[$i]["pkirisdate"][0], 8, 2);
            $minuto = substr($result[$i]["pkirisdate"][0], 10, 2);
            $segundo = substr($result[$i]["pkirisdate"][0], 12, 2);
            $fecha = $dia."/".$mes."/".$anio." - ".$hora.":".$minuto.":".$segundo;
	    $status = $result[$i]["pkirisstatus"][0];
            if ($i%2==0){
               echo "<tr>
                  <td class='even'>$copa</td>
                  <td class='even'>$ident</td>
                  <td class='even'>$fecha</td>
                  <td class='even'>$status</td>
                 </tr>\n";
            }
            else {
               echo "<tr>
                  <td class='odd'>$copa</td>
                  <td class='odd'>$ident</td>
                  <td class='odd'>$fecha</td>
                  <td class='odd'>$status</td>
                </tr>\n";
            }

            echo "<input type='hidden' name='pkiId$i' value='$copa'>\n";
         }
         echo "</table>
         <br/>
         <input type='hidden' name='cantId' value='$i'>
         <input type='hidden' name='csr_command' value='make_xml'>
         <input class='button' type='submit' value='Enviar a la RA' />
         </form>\n";
      }
   
   break;

   case "make_xml": //Crea la solicitud para exportar a la RA en xml
      $cant = $_POST["cantId"];

      echo "<h1 class='title'>Exportaci&oacute;n de las solicitudes a la RA</h1>
            <h3> Hay $cant certificados, revocaciones y/o solicitudes rechazadas que se van a enviar a la RA </h3>\n";
      
      // En primer lugar generamos el fichero XML que servira para enviar los
      // datos a la RA. Necesitaremos un array con los codigos copa de todas
      // las solicitudes que se van a exportar
      $copasArray = array ();
      for ($i = 0; $i < $cant; $i++) {
         $copa = $_POST["pkiId$i"];
	 array_push( $copasArray, $copa);
	 $status = getStatus($copa);
         if ( !$status ) 
	    $errorCode = "a2b1c3d2e2";
         else if ( $status == "revoke") {
	    // Las revocaciones pendientes las exportaremos de una en una,
	    $xmlString = createXML ( $copasArray );
            if ( !$xmlString )
               $errorCode = "a2b1c3d2e1";
            else { 
  	       // por lo que una vez generado el XML, la sacamos del array
	       array_pop( $copasArray );	    
            }
	 }
      }
	   
      if ( $errorCode == "a0" ) {
         // Generamos el fichero y guardamos el codigo XML en una variable, 
         // si al menos hay una solicitud/certificado a exportar
         if ( $copasArray != null ) { 
            $xmlString = createXML ( $copasArray );
            if ( !$xmlString )
               $errorCode = "a2b1c3d2e1";
            else {
               // Si no ha habido errores, enviamos un mail al administrador
               $envioMail = mail($ldapVar['adminCaMail'], "CSR Aprobada", "Se ha generado un archivo de exportaci&oacute;n con $cant solicitudes para ser enviadas a la CA\n\n\n$xmlString");
               $pkiLog['status'] = "data_export";
               $pkiLog['eee'] = "none";
               $pkiLog['user'] = "CA-Admin";
               $pkiLog['error'] = $errorCode;
               writeLog ($status, $copa, $user, $errorCode);
               echo "\n<p>La exportaci&oacute;n se ha efectuado con &eacute;xito.</p>\n";
            }
         }
      }
      break;
}

// Si se ha producido algun error, llamamos a la funcion encargada de
// tratarlos
if ( $errorCode != "a0" ) {
   echo "<h3>Error en la exportaci&oacute;n.</h3>";

   $pkiLog['status'] = "data_export";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "CA-Admin";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);
}

pie ();
	
?>
